local mod = ...



-- Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/Authority2.fbx/Prefab/GardenerMaleFront", "PREFAB_AUTHORITY_GARDENER_MALE_FRONT")
mod:registerAssetId("models/Authority2.fbx/Prefab/GardenerMaleHat", "PREFAB_AUTHORITY_GARDENER_MALE_HAT")
mod:registerAssetId("models/Authority2.fbx/Prefab/GardenerFemaleFront", "PREFAB_AUTHORITY_GARDENER_FEMALE_FRONT")
mod:registerAssetId("models/Authority2.fbx/Prefab/GardenerFemaleHat", "PREFAB_AUTHORITY_GARDENER_FEMALE_HAT")



-- Resource: Instructions (Garden) -------------------------------------------------------------------------------------
mod:registerAssetId("icons/Instructions.png", "ICON_INSTRUCTIONS")

mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_INSTRUCTIONS",
	ResourceName = "RESOURCE_INSTRUCTIONS_NAME",
	Icon = "ICON_INSTRUCTIONS",
	ResourceTypeList = { "RESOURCE_TYPE_AUTHORITY" },
	IsTradable = false,
    DisplayInInventory = false,
	DisplayInToolbar = false,
	OrderId = 0
})



-- Job: Gardener -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_AUTHORITY_GARDENER",
	JobName = "JOB_AUTHORITY_GARDENER_NAME",
	JobDescription = "JOB_AUTHORITY_GARDENER_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 30.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        -- RightHandObject = {
		-- 	DataType = "HAND_OBJECT",
        --     Model = "PREFAB_TOOL_GUARD_SPEAR"
        -- },
        MaleHatList = {
            "PREFAB_AUTHORITY_GARDENER_MALE_HAT",
        },
        MaleFrontList = {
            "PREFAB_AUTHORITY_GARDENER_MALE_FRONT",
        },
        FemaleHatList = {
            "PREFAB_AUTHORITY_GARDENER_FEMALE_HAT",
        },
        FemaleFrontList = {
            "PREFAB_AUTHORITY_GARDENER_FEMALE_FRONT",
        },
		WalkAnimation = "WALKING",
		IdleAnimation = "FORESTER"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_GARDENER"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_GARDENER"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_GARDENER"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_GARDENER"
    }
})



-- Job: Garden Helper -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_AUTHORITY_GARDENERHELPER",
	JobName = "JOB_AUTHORITY_GARDENERHELPER_NAME",
	JobDescription = "JOB_AUTHORITY_GARDENERHELPER_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 60.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        -- RightHandObject = {
		-- 	DataType = "HAND_OBJECT",
        --     Model = "PREFAB_TOOL_GUARD_SPEAR"
        -- },
        MaleHatList = {
            "PREFAB_AUTHORITY_GARDENER_MALE_HAT",
        },
        FemaleHatList = {
            "PREFAB_AUTHORITY_GARDENER_FEMALE_HAT",
        },
        -- FemaleFrontList = {
        --     "PREFAB_AUTHORITY_GROOM_FEMALE_FRONT",
        -- },
        -- FemaleBeltList = {
        --     "PREFAB_AUTHORITY_BLANK",
        -- },
        -- MaleClothingModel = {
        --     "PREFAB_AUTHORITY_GROOM_MALE_CLOTHES",
        -- },
		WalkAnimation = "WALKING",
		IdleAnimation = "FORESTER"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_GARDENERHELPER"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_GARDENERHELPER"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_GARDENERHELPER"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_GARDENERHELPER"
    }
})



-- Building Function: Gardener -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_AUTHORITY_GARDENSHED",
	Name = "BUILDING_FUNCTION_AUTHORITY_GARDENSHED_NAME",
	HasMaximumInstance = true,
	MaximumInstanceAllowed = 1,
	WorkerCapacity = 1,
	UpkeepPerWorker = {
		{
			Resource = "GOLD_COINS",
			Quantity = 2
		}
	},
    RelatedJob = { 
        Job = "JOB_AUTHORITY_GARDENER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
        { Resource = "RESOURCE_INSTRUCTIONS", Quantity = 1 },
    }
})



-- Building Function: Garden Helper -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_AUTHORITY_GARDENPOST",
	Name = "BUILDING_FUNCTION_AUTHORITY_GARDENPOST_NAME",
	HasMaximumInstance = true,
	MaximumInstanceAllowed = 3,
	WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_AUTHORITY_GARDENERHELPER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
        { Resource = "RESOURCE_WAGE", Quantity = 10 },
        { Resource = "RESOURCE_INSTRUCTIONS", Quantity = 10 },
        { Resource = "WATER", Quantity = 10 },
        { Resource = "RESOURCE_COMPOST", Quantity = 10 },
	},
    ResourceListNeeded = {
        { Resource = "RESOURCE_WAGE", Quantity = 3 },
        { Resource = "RESOURCE_INSTRUCTIONS", Quantity = 1 },
        { Resource = "WATER", Quantity = 1 },
        { Resource = "RESOURCE_COMPOST", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_AUTHORITY", Quantity = 1 },
    }
})

